#include "kfunctionedit.h"

KFunctionEdit::KFunctionEdit(QWidget *parent, const char *name, bool modal, WFlags) : KDialogBase (parent, name, modal, i18n("Add/Edit a function"), Ok|Cancel, Ok, false) {
	QWidget *page = new QWidget( this );
	setMainWidget(page);
	page->setFixedWidth(400);
	page->setFixedHeight(300);
	setFixedWidth(400);
	setFixedHeight(300);
	
	QVBoxLayout *topLayout = new QVBoxLayout( page, 0, spacingHint() );
	
	m_func = new KLineEdit( "x^sin(x)", page, "lineedit" );
	connect(m_func, SIGNAL(textChanged ( const QString & )), this, SLOT(edit()));
	topLayout->addWidget(m_func);

	m_color = new KColorCombo(page);
	m_color->setColor(QColor(0,150,0));
// 	m_color->setColor(QColor(255,0,0));
	topLayout->addWidget(m_color);
	
	m_valid = new QLabel("<qt text='red'></qt>", page);
	topLayout->addWidget(m_valid);
	
	QHBox *raro = new QHBox(page);
	raro->setFrameStyle( QFrame::Box | QFrame::Plain );
	raro->setLineWidth(1);
	topLayout->addWidget(raro);
	
	m_graph = new QGraph(raro);
	m_graph->setViewPort(QRect::QRect(QPoint::QPoint(-9, -5), QPoint::QPoint(9, 5)));
	m_graph->setResolution(90);
	m_graph->setMouseTracking(false);
	m_graph->setFocusPolicy(NoFocus);
// 	topLayout->addWidget(m_graph);
	
	edit();
	m_func->setFocus();
}

KFunctionEdit::~KFunctionEdit(){}

void KFunctionEdit::edit(){
	//Let's see if the exp is correct
	if(m_func->text()[0]=='<'){
		Analitza a;
		if(a.setTextMML(m_func->text())){
			m_valid->setText(i18n("<qt text='red'><b>WRONG</b></qt>"));
		} else {
			m_valid->setText(i18n("<qt text='#090'><b>f(x)=%1</b></qt>").arg(Analitza::treu_tags(a.toString())));
			QValueList<QColor> col;
			col << m_color->color();
			m_graph->setFunc(m_func->text(), col);
		}
	} else {
		QExp a(m_func->text());
		a.parse();
		if(a.error() != ""){
			m_valid->setText(i18n("<qt text='red'><b>WRONG</b></qt>"));
		} else {
			m_valid->setText(i18n("<qt text='#090'>f(x)=<b>%1</b></qt>").arg(m_func->text()));
			QValueList<QColor> col;
			col << m_color->color();
			m_graph->setFunc(a.mathML(), col);
		}
	}
}

#include "kfunctionedit.moc"
